<template>
<div :class="this.classes">
	<div class="list categories">
		<standard-item
			v-for="cat in categories"
			v-on:hover="onCategoryHover"
			:key="cat.id"
			:id="cat.id"
			:selected="category === cat.id"
		>{{ cat.name }}</standard-item>
	</div>
	<div class="list items">
		<standard-item
			v-for="cat in categories[category].items"
			v-on:click="onItemClick"
			v-on:hover="onItemHover"
			:key="cat.key"
			:highlighted="cat.id === highlight"
			:id="cat.key"
			:selected="selected === cat.key"
		>{{ cat.name }}</standard-item>
	</div>
</div>
</template>

<script>
import { BODY_MESHES, WHEEL_MESHES } from "../../constants/car.js"

import StandardItem from "./StandardItem.vue"

export default {
	components: { StandardItem },
	computed: {
		classes () {
			return {
				"car-part-selector": true,
				[`part_${this.id}`]: true
			}
		},
		highlight () {
			if (this.category === 0) {
				return this.config.body
			} else {
				return this.config.wheel
			}
		},
		selected () {
			return this.categories[this.category].selected
		}
	},
	data () {
		return {
			category: 0,
			categories: [{
				id: 0,
				items: BODY_MESHES.map((mesh, key) => {
					return {
						key,
						id: mesh.id,
						name: mesh.name,
					}
				}),
				name: "Body Types",
				selected: BODY_MESHES.findIndex((mesh) => {
					return mesh.id === this.config.body
				}),
			}, {
				id: 1,
				items: WHEEL_MESHES.map((mesh, key) => {
					return {
						key,
						id: mesh.id,
						name: mesh.name,
					}
				}),
				name: "Wheel Types",
				selected: WHEEL_MESHES.findIndex((mesh) => {
					return mesh.id === this.config.wheel
				}),
			}],
			in_category_selector: false,
		}
	},
	methods: {
		onCategoryHover (id) {
			this.category = id
		},
		onItemClick (id) {
			if (this.category === 0) {
				this.$emit("change-body", this.id, BODY_MESHES[id].id)
			} else {
				this.$emit("change-wheel", this.id, WHEEL_MESHES[id].id)
			}
		},
		onItemHover (id) {
			this.categories[this.category].selected = id
		}
	},
	name: "car-part-selector",
	props: [ "id", "config", "input" ]
}
</script>

<style lang="less" scoped>
.car-part-selector {
	background-color: #000;
	border: 1px #fff solid;
	color: #fff;
	display: flex;
	font-size: 1.5em;
	height: 15em;
	position: absolute;
	width: 30em;
}

.list {
	flex: 1;

	> * {
		padding: 1em;
	}
}

.part_0 {
	left: 1em;
	top: 17em;
}

.part_1 {
	right: 1em;
	top: 17em;
}

.part_2 {
	bottom: 1em;
	left: 1em;
}

.part_3 {
	bottom: 1em;
	right: 1em;
}
</style>
